//
//  NewListViewController.m
//  new_info
//
//  Created by beifeng on 1/8/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "NewListViewController.h"
#import "NewDetailViewController.h"
#import "NewViewController.h"
@implementation NewListViewController
@synthesize url;


- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        style =UITableViewStyleGrouped;
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    self.title =@"国际新闻";
    
    dataArray = [[NSMutableArray alloc]init];
    dictionary = [[NSMutableDictionary alloc]init];
    cstring = [[NSMutableString alloc]init];
    if (url==nil) {
        url = glob_url;
    }
    
    NSData *data =[NSData dataWithContentsOfURL:url];
    
    NSXMLParser *parser = [[NSXMLParser alloc]initWithData:data];
    [data release];
    [parser setDelegate:self];
    [parser parse];
    
}

// Document handling methods
- (void)parserDidStartDocument:(NSXMLParser *)parser{
    [dataArray removeAllObjects];
}
// sent when the parser begins parsing of the document.
- (void)parserDidEndDocument:(NSXMLParser *)parser{
    [self.tableView reloadData];
}


- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName attributes:(NSDictionary *)attributeDict{
    if ([elementName isEqualToString:@"item"]) {
        
        [dictionary removeAllObjects];
    }
    else if([elementName isEqualToString:@"type"]){
    
        [cstring setString:@""];
    }else if([elementName isEqualToString:@"name"]){
        [cstring setString:@""];
        
    }else if([elementName isEqualToString:@"iconName"]){
    
        [cstring setString:@""];
    }else if([elementName isEqualToString:@"desc"]){
    
        [cstring setString:@""];
    }else if([elementName isEqualToString:@"link"]){
    
        [cstring setString:@""];
    
    }



}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName{
    if ([elementName isEqualToString:@"item"]) {
        [dataArray addObject:[NSDictionary dictionaryWithDictionary:dictionary]];
    }else if([elementName isEqualToString:@"type"]){
        
        [dictionary setObject:[NSString stringWithString:cstring] forKey:@"type"];
        
    }else if([elementName isEqualToString:@"name"]){
        [dictionary setObject:[NSString stringWithString:cstring] forKey:@"name"];
        
    }else if([elementName isEqualToString:@"iconName"]){
        [dictionary setObject:[NSString stringWithString:cstring] forKey:@"iconName"];
       
    }else if([elementName isEqualToString:@"desc"]){
        [dictionary setObject:[NSString stringWithString:cstring] forKey:@"desc"];
       
    }else if([elementName isEqualToString:@"link"]){
        
        [dictionary setObject:[NSString stringWithString:cstring] forKey:@"link"];
    }
    


}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string{
    [cstring appendString:string];

}

-(void)dealloc{
    [dataArray release];
    [dictionary release];
    [cstring release];

}


- (void)viewDidUnload
{
    [super viewDidUnload];
   
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{

    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{

    // Return the number of rows in the section.
    return [dataArray count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
       
            
            NSDictionary *dic = [dataArray objectAtIndex:indexPath.row];
        
        
        //初始化cell上的组件
        imgHead = [[UIImageView alloc]initWithFrame:CGRectMake(15, 6, 50, 30)];
        imgHead.backgroundColor =[UIColor clearColor];
        //if ([dic objectForKey:@"iconName"] ==nil) {
            imgHead.image =[UIImage imageNamed:@"sn_3.jpg"];
            NSLog(@"have  not.....");
        //}else{
           // imgHead.image =[NSURL URLWithString:[dic objectForKey:@"iconName"]];
            NSLog(@"have.....");

       // }
        [cell addSubview:imgHead];
        [imgHead release];
        
        title = [[UILabel alloc]initWithFrame:CGRectMake(150, 6, 100, 15)];
        title.backgroundColor = [UIColor clearColor];
        title.text =[dic objectForKey:@"name"];
        title.font = [UIFont systemFontOfSize:12.0f];
        [cell addSubview:title];
        [title release];
        
        time = [[UILabel alloc]initWithFrame:CGRectMake(150, 25, 100, 15)];
        time.backgroundColor =[UIColor clearColor];
        time.text =[dic objectForKey:@"desc"];
        time.font =[UIFont systemFontOfSize:10.0];
        [cell addSubview:time];
        [time release];
       // NSLog(@"indexPaht%@",indexPath.row);
        
      
        
        /**
        switch (indexPath.row) {
            case 0:
                //
                imgHead.image =[UIImage imageNamed:@"sn_3.jpg"];
                title.text =@"拿高薪上北风网";
                time.text =@"2012-3-10";
                break;
            case 1:
                           //
                break;
                
            default:
                break;
        }
        */
             
    }
    
    // Configure the cell...
    cell.accessoryType =UITableViewCellAccessoryDisclosureIndicator;
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    NewDetailViewController *detailViewController = [[[NewDetailViewController alloc]init]autorelease];
    detailViewController.htmlString = [dictionary objectForKey:@"link"];
    [self.navigationController pushViewController:detailViewController animated:YES];
    
}

@end
